# Reference

<!-- DO NOT EDIT: This document was generated by Puppet Strings -->

## Table of Contents

### Functions

* [`azure_key_vault::lookup`](#azure_key_vault--lookup)
* [`azure_key_vault::secret`](#azure_key_vault--secret): Retrieves secrets from Azure's Key Vault.

## Functions

### <a name="azure_key_vault--lookup"></a>`azure_key_vault::lookup`

Type: Ruby 4.x API

The azure_key_vault::lookup function.

#### `azure_key_vault::lookup(Variant[String, Numeric] $secret_name, Struct[{
      vault_name => String,
      vault_api_version => String,
      Optional[metadata_api_version] => String,
      confine_to_keys => Array[String],
      Optional[key_replacement_token] => String,
      Optional[service_principal_credentials] => String
    }] $options, Puppet::LookupContext $context)`

The azure_key_vault::lookup function.

Returns: `Variant[Sensitive, Undef]`

##### `secret_name`

Data type: `Variant[String, Numeric]`



##### `options`

Data type:

```puppet
Struct[{
      vault_name => String,
      vault_api_version => String,
      Optional[metadata_api_version] => String,
      confine_to_keys => Array[String],
      Optional[key_replacement_token] => String,
      Optional[service_principal_credentials] => String
    }]
```



##### `context`

Data type: `Puppet::LookupContext`



### <a name="azure_key_vault--secret"></a>`azure_key_vault::secret`

Type: Ruby 4.x API

Retrieves secrets from Azure's Key Vault.

#### `azure_key_vault::secret(String $vault_name, String $secret_name, Struct[{
      vault_api_version => String,
      Optional[metadata_api_version] => String,
      Optional[service_principal_credentials] => Struct[{
        tenant_id => String,
        client_id => String,
        client_secret => String
      }]
    }] $api_endpoint_hash, Optional[String] $secret_version)`

Retrieves secrets from Azure's Key Vault.

Returns: `Sensitive[String]` Returns the secret as a String wrapped with the Sensitive data type.

##### `vault_name`

Data type: `String`

Name of the vault in your Azure subscription.

##### `secret_name`

Data type: `String`

Name of the secret to be retrieved.

##### `api_endpoint_hash`

Data type:

```puppet
Struct[{
      vault_api_version => String,
      Optional[metadata_api_version] => String,
      Optional[service_principal_credentials] => Struct[{
        tenant_id => String,
        client_id => String,
        client_secret => String
      }]
    }]
```

A Hash with API endpoint and authentication information

##### `secret_version`

Data type: `Optional[String]`

The version of the secret you want to retrieve.  This parameter is optional and if not passed the default behavior is to retrieve the latest version.

